﻿Type=Class
Version=2.71
@EndOfDesignText@
'ClsDBField v1.4
'Basic4Android v2.70 Class
'Developed by QUALISYS SOFTWARE

'Class module
Sub Class_Globals
	Type typDBAwareViews(Module As Object)
	Private cName 			As String
	Private cOriginalName	As String
	Private cTable			As String
	Private cOriginalTable	As String
	Private cMaxLength 		As Long
	Private cLength 		As Long
	Private iMinValue       As Double
	Private iMaxValue       As Double
	Private cFieldType 		As String
	Private cAutoIncrement  As Boolean
	Private cUniqueKey	    As Boolean
	Private cIndex 			As Long
	Private cValue 			As Object
	Private cOrigValue 		As Object
	Private cReadOnly		As Boolean
	Private cRequired 		As Boolean
	Private cNumberFormat   As String
	
	Private cDBMySQLDataset As ClsDBMySQLDataset
	Private DBAwareViews   As List
End Sub

'Initializes the object. You can add parameters to this method if needed.
'DBMySQLDataset =  ClsDBMySQLDataset
Public Sub Initialize(DBMySQLDataset As ClsDBMySQLDataset)
	cDBMySQLDataset = DBMySQLDataset
	cValue = Null
	DBAwareViews.Initialize
End Sub

'Set the field name
Public Sub setName(Name As String) As ClsDBField
	cName = Name
	Return Me
End Sub

'Get the field name
Public Sub getName As String
	Return cName
End Sub

'Set the field OriginalName
Public Sub setOriginalName(OriginalName As String) As ClsDBField
	cOriginalName = OriginalName
	Return Me
End Sub

'Get the field OriginalName
Public Sub getOriginalName As String
	Return cOriginalName
End Sub

'Set the field Table
Public Sub setTable(Table As String) As ClsDBField
	cTable = Table
	Return Me
End Sub

'Get the field Table
Public Sub getTable As String
	Return cTable
End Sub

'Set the field OriginalTable
Public Sub setOriginalTable(OriginalTable As String) As ClsDBField
	cOriginalTable = OriginalTable
	Return Me
End Sub

'Get the field OriginalTable
Public Sub getOriginalTable As String
	Return cOriginalTable
End Sub

'Set the field MaxLength
Public Sub setMaxLength(MaxLength As Long) As ClsDBField
	cMaxLength = MaxLength
	Return Me
End Sub

'Get the field MaxLength
Public Sub getMaxLength As Long
	Return cMaxLength
End Sub

'Set the field MinValue
Public Sub setMinValue(Value As Double) As ClsDBField
	iMinValue = Value
	Return Me
End Sub

'Get the field MinValue
Public Sub getMinValue As Double
	Return iMinValue
End Sub

'Set the field MaxValue
Public Sub setMaxValue(Value As Double) As ClsDBField
	iMaxValue = Value
	Return Me
End Sub

'Get the field MaxValue
Public Sub getMaxValue As Double
	Return iMaxValue
End Sub

'Set the field Length
Public Sub setLength(Length As Long) As ClsDBField
	cLength = Length
	Return Me
End Sub

'Get the field Length
Public Sub getLength As Long
	Return cLength
End Sub

'Set the field FieldType
Public Sub setFieldType(FieldType As String) As ClsDBField
	cFieldType = FieldType
	Return Me
End Sub

'Get the field FieldType
Public Sub getFieldType As String
	Return cFieldType
End Sub

'Set the field AutoIncrement
Public Sub setAutoIncrement(AutoIncrement As Boolean) As ClsDBField
	cAutoIncrement = AutoIncrement
	Return Me
End Sub

'Get the field AutoIncrement
Public Sub getAutoIncrement As Boolean
	Return cAutoIncrement
End Sub

'Set the field UniqueKey
Public Sub setUniqueKey(UniqueKey As String) As ClsDBField
	cUniqueKey = UniqueKey
	Return Me
End Sub

'Get the field UniqueKey
Public Sub getUniqueKey As String
	Return cUniqueKey
End Sub

'Set the field Index
Public Sub setIndex(Index As Long) As ClsDBField
	cIndex = Index
	Return Me
End Sub

'Get the field Index
Public Sub getIndex As Long
	Return cIndex
End Sub

Private Sub CheckInsertOrEdit
	Dim Ex As ExceptionEx

	If (cDBMySQLDataset = Null) OR (cDBMySQLDataset <> Null AND cDBMySQLDataset.State <> CodDB.dsInsert) AND (cDBMySQLDataset.State <> CodDB.dsEdit)  Then
		Ex.Initialize(CodDB.SNotEditing)
		Ex.Throw
	End If
End Sub

'Set the field Value
Public Sub setValue(Value As Object) As ClsDBField
	If Not(cValue = Null AND Value = Null) AND ((cValue = Null AND Value <> Null) OR (cValue <> Null AND Value = Null) OR (Value <> cValue)) Then
		CheckInsertOrEdit
		cValue = Value
		CallFieldChange
	End If
	Return Me
End Sub

'Get the field Value
Public Sub getValue As Object
	If cValue = Null Then
		Return Null
	Else
		Return cValue
	End If
End Sub

'Set the field Value as String
Public Sub setAsString(Value As String) As ClsDBField
	If cMaxLength > 0 AND Value.Length > cMaxLength Then Value = Value.SubString2(0, cMaxLength - 1)

	Select getFieldType
		Case CodDB.ftBLOB, CodDB.ftLONGBLOB, CodDB.ftMEDIUMBLOB, CodDB.ftTINYBLOB
			Dim su As StringUtils			
			Value = su.EncodeBase64(Value.GetBytes("UTF8"))
	End Select

	Return setValue(Value)
End Sub

'Get the field Value As a String
Public Sub getAsString As String
	If cValue = Null Then
		Return ""
	Else		
		Dim sValue As String
		Select getFieldType
			Case CodDB.ftVARCHAR, CodDB.ftCHAR, CodDB.ftUNKNWOWN				
				sValue = cValue
			Case CodDB.ftTINYINT, CodDB.ftINT, CodDB.ftFLOAT, CodDB.ftDOUBLE, CodDB.ftBIT, CodDB.ftBIGINT, CodDB.ftMEDIUMINT, CodDB.ftYEAR  
				sValue = GetNumberFormated(cValue)
			Case CodDB.ftTIMESTAMP, CodDB.ftDATE, CodDB.ftTIME, CodDB.ftDATETIME
				sValue = DateTime.Date(cValue)
			Case CodDB.ftBLOB, CodDB.ftLONGBLOB, CodDB.ftMEDIUMBLOB, CodDB.ftTINYBLOB
				Dim su As StringUtils
				Dim bt() As Byte
				Dim bc As ByteConverter
				bt = su.DecodeBase64(cValue)
				sValue = bc.StringFromBytes(bt, cDBMySQLDataset.MySQLConnection.charset)
			Case CodDB.ftBOOLEAN
				If cValue = True Then
					sValue = "1"
				Else
					sValue = "0"
				End If
			Case CodDB.ftENUM, CodDB.ftSET, CodDB.ftGEOMETRY
				sValue = cValue
			Case Else
				sValue = cValue
		End Select
		Return sValue
	End If
End Sub

'Set the field Value as Int
Public Sub setAsInt(Value As Int) As ClsDBField
	Return setValue(Value)
End Sub

'Get the field Value As an Int
Public Sub getAsInt As Int
	If cValue = Null Then
		Return 0
	Else
		Dim iValue As Int
		iValue = cValue
		Return iValue
	End If
End Sub

'Set the field Value as Long
Public Sub setAsLong(Value As Long) As ClsDBField
	Return setValue(Value)
End Sub

'Get the field Value As an Long
Public Sub getAsLong As Long
	If cValue = Null Then
		Return 0
	Else
		Dim iValue As Long
		
		If cValue Is Boolean AND cValue = True Then
			iValue = 1
		Else If cValue Is Boolean AND cValue = False Then
			iValue = 0
		Else		
			iValue = cValue
		End If
		Return iValue
	End If
End Sub

'Set the field Value as double
Public Sub setAsDouble(Value As Double) As ClsDBField
	Return setValue(Value)
End Sub

'Get the field Value As an Double
Public Sub getAsDouble As Double
	If cValue = Null Then
		Return 0
	Else
		Dim iValue As Double
		iValue = cValue
		Return iValue
	End If
End Sub

'Set the field Value as DateTime
Public Sub setAsDateTime(Value As Long) As ClsDBField
	Return setValue(Value)
End Sub

'Get the field Value As an DateTime
Public Sub getAsDateTime As Long
	If cValue = Null Then
		Return 0
	Else
		Return cValue
	End If
End Sub

'Set the field Value As an Boolean
Public Sub setAsBoolean(Value As Boolean) As ClsDBField
	Return setValue(Value)
End Sub

'Get the field Value As an Boolean
Public Sub getAsBoolean As Boolean
	If cValue = Null  Then
		Return False
	Else If IsNumber(cValue) AND cValue = 1 Then
		Return True
	Else If cValue = "1" Then
		Return True	
	Else If cValue Is Boolean AND cValue = True Then
		Return True	
	Else If cValue Is Boolean AND cValue = False Then
		Return False
	Else 
		Dim bValue As Int
		Try
			bValue = cValue
		Catch
			Return False
		End Try
		If bValue = 1 Then 
			Return True
		Else
			Return False
		End If
	End If
End Sub

'Set the field Value As Byte() Base64 Encoded. Used for BLOBS
Public Sub setAsBytes(Value() As Byte) As ClsDBField
	Dim su As StringUtils

	Return setValue(su.EncodeBase64(Value))
End Sub

'Get the field Value As Byte() used for BLOBS
Public Sub getAsBytes As Byte()
	If cValue = Null OR cValue = "" Then
		Return Null
	Else 
		Dim su As StringUtils
		Dim bt() As Byte
		Try
			bt = su.DecodeBase64(cValue)
			Return bt
		Catch
			Return Null
		End Try
	End If
End Sub

'Set the field Value As Bitmap used for BLOBS
Public Sub setAsBitmap(Value As Bitmap, Quality As Long) As ClsDBField
    Dim out As OutputStream
    Dim Data() As Byte	
	Dim su As StringUtils
	
    out.InitializeToBytesArray(1)    
    Value.WriteToStream(out, Quality, "JPEG")    
    Data = out.ToBytesArray    
    out.Close
	Return setValue(su.EncodeBase64(Data))
End Sub

'Set the field Original Value
Public Sub setOriginalValue(Value As Object) As ClsDBField
	cOrigValue = Value
	Return setValue(Value)
End Sub

'Get the Original field Value
Public Sub getOriginalValue As Object
	Return cOrigValue
End Sub

'Check if the field Value is null
Public Sub IsNull As Object
	Return (cValue = Null)
End Sub

'Get the string field Value, base64 encoded. Return "" if not string
Public Sub getStringValueAsBase64 As String
	If cValue = Null Then
		Return ""
	Else		
		Dim sValue As String
		Dim su As StringUtils
		Select getFieldType
			Case CodDB.ftVARCHAR, CodDB.ftCHAR, CodDB.ftUNKNWOWN				
				sValue = cValue
				sValue = su.EncodeBase64(sValue.GetBytes("UTF8"))
			Case CodDB.ftTINYINT, CodDB.ftINT, CodDB.ftFLOAT, CodDB.ftDOUBLE, CodDB.ftBIT, CodDB.ftBIGINT, CodDB.ftMEDIUMINT, CodDB.ftYEAR  
				sValue = cValue
				sValue = su.EncodeBase64(sValue.GetBytes("UTF8"))
			Case CodDB.ftTIMESTAMP, CodDB.ftDATE, CodDB.ftTIME, CodDB.ftDATETIME
				sValue = DateTime.Date(cValue)
				sValue = su.EncodeBase64(sValue.GetBytes("UTF8"))
			Case CodDB.ftBLOB, CodDB.ftLONGBLOB, CodDB.ftMEDIUMBLOB, CodDB.ftTINYBLOB
				sValue = cValue	'BLOBs are already Base64 Encoded
			Case CodDB.ftBOOLEAN
				If cValue = True Then
					sValue = "1"
				Else
					sValue = "0"
				End If
				sValue = sValue
				sValue = su.EncodeBase64(sValue.GetBytes("UTF8"))
			Case CodDB.ftENUM, CodDB.ftSET, CodDB.ftGEOMETRY
				sValue = cValue
				sValue = su.EncodeBase64(sValue.GetBytes("UTF8"))
			Case Else
				sValue = cValue
				sValue = su.EncodeBase64(sValue.GetBytes("UTF8"))
		End Select
		Return sValue
	End If
End Sub

'Get the Original string field Value, base64 encoded. Return "" if not string
Public Sub getOriginalStringValueAsBase64 As String
	Dim su As StringUtils
	Dim str As String
	
	If cOrigValue Is String Then
		str = cOrigValue
		Return su.EncodeBase64(str.GetBytes("UTF8"))
	Else
		Return ""
	End If
End Sub

'Set the field ReadOnly
Public Sub setReadOnly(ReadOnly As Boolean) As ClsDBField
	cReadOnly = ReadOnly
	Return Me
End Sub

'Get the field ReadOnly
Public Sub getReadOnly As Boolean
	Return cReadOnly
End Sub

'Set the field Required
Public Sub setRequired(Required As Boolean) As ClsDBField
	cRequired = Required
	Return Me
End Sub

'Get the field Required
Public Sub getRequired As Boolean
	Return cRequired
End Sub

'Get the string used for Number Formater
Sub getNumberFormat As String
	Return cNumberFormat
End Sub

'Set the string used for Number Formater
Sub setNumberFormat(Value As String)
	cNumberFormat = Value
End Sub

Private Sub GetNumberFormated(i As Double) As String
	Dim an As AHNumeric
	an.InitializeNumber
	an.Pattern = cNumberFormat
'	an.MaximumFractionDigits = iDecimalPlaces
'	an.MinimumFractionDigits = iDecimalPlaces
	Return an.Format(i)	
End Sub

'Subscribe View to receive Dataset's events
Sub SubscribeView(Module As Object)
	Dim DBAwareView As typDBAwareViews
	
	DBAwareView.Initialize
	DBAwareView.Module = Module
	DBAwareViews.Add(DBAwareView)
	If SubExists(DBAwareView.Module, "DataChange") Then CallSub(DBAwareView.Module, "DataChange")
End Sub

Private Sub CallFieldChange
	Dim i As Int
	Dim DBAwareView As typDBAwareViews
	
	For i = 0 To DBAwareViews.Size - 1
		DBAwareView = DBAwareViews.get(i)
		Log(DBAwareView)
		Log(DBAwareView.Module)
		If DBAwareView.IsInitialized Then
			If SubExists(DBAwareView.Module, "DataChange") Then CallSub(DBAwareView.Module, "DataChange")
		End If
	Next
End Sub