﻿Type=Class
Version=2.71
@EndOfDesignText@
'ClsDBMySQLconnection v1.4
'Basic4Android v2.70 Class
'Developed by QUALISYS SOFTWARE
'Use mysqltunnel.php v1.0 
'https://sourceforge.net/projects/mysqltunnel/

'Class module
Sub Class_Globals
	Type typMySQLConnection(HTTPTunnel, Host, Port, DataBase, UserName, Password, Charset As String, Compress As Byte)	
	Type typMySQLConnectionAction(ActionName As String, Module As Object, OnJobSuccessSub As String, OnJobFailureSub As String)
	Private MySQLConnection As typMySQLConnection
	Private cHashKey As String
	Private Actions As List
End Sub

'Initializes ClsDBMySQLconnection.
'HTTPTunnel = http://path_to_webservice/tunnel.php
'Host       = MySQL Host. If blank localhost will be used
'Port		= Port to connect. If blank uses the server's default
'DataBase	= Database to be used. If blank database will be provided in Query
'UserName	= Username to authenticate to MySQL
'Password	= Password to authenticate to MySQL
'Charset	= Charset to be used for MySQL
'Compress	= Ask the Tunnel to Compress the Result to save Network bandwidth
'HasKey     = HaskKey used for the encryption. Only ASCII characters are acceptable. Should be the same as in mysqltunnel.php. Leave blank for no encryption
Public Sub Initialize(HTTPTunnel As String, Host As String, Port As String, DataBase As String, UserName As String, Password As String, Charset As String, Compress As Boolean, HashKey As String)
	MySQLConnection.Initialize
	MySQLConnection.HTTPTunnel = HTTPTunnel
	If Host = "" Then Host = "localhost"
	MySQLConnection.Host = Host
	MySQLConnection.DataBase = DataBase
	MySQLConnection.UserName = UserName
	MySQLConnection.Password = Password
	MySQLConnection.Charset = Charset
	MySQLConnection.Port = Port 
	If Compress Then
		MySQLConnection.Compress = 1
	Else
		MySQLConnection.Compress = 0
	End If
	cHashKey = HashKey

	Actions.Initialize
End Sub

Private Sub Encrypt(dataToEncrypt As String) As String
    Dim su As StringUtils
    Dim kg As KeyGenerator
    Dim C As Cipher
    Dim md As MessageDigest
    Dim encrypted() As Byte
	
	If cHashKey.Trim = "" Then Return False

    kg.Initialize("AES")
    kg.KeyFromBytes(md.GetMessageDigest(cHashKey.GetBytes("UTF8"), "MD5"))
	    
    C.Initialize("AES/ECB/PKCS5Padding")
    encrypted = C.Encrypt(dataToEncrypt.GetBytes("UTF8"), kg.Key, False)

    Return su.EncodeBase64(encrypted)
End Sub

Private Sub Decrypt(dataToDecrypt As String) As String
    Dim su As StringUtils
    Dim kg As KeyGenerator
    Dim C As Cipher
    Dim md As MessageDigest
    Dim decrypted() As Byte
	Dim BConv As ByteConverter
	
	If cHashKey.Trim = "" Then Return False

    kg.Initialize("AES")
    kg.KeyFromBytes(md.GetMessageDigest(cHashKey.GetBytes("UTF8"), "MD5"))
	    
    C.Initialize("AES/ECB/PKCS5Padding")

	decrypted = su.DecodeBase64(dataToDecrypt)
    decrypted = C.Decrypt(decrypted, kg.Key, False)

    Return BConv.StringFromBytes(decrypted, "UTF8")
End Sub

'Sends the Script to the Tunnel
'Script				= SQL script to execute
'OnJobSuccessSub 	= Sub to call on JobSuccess
'OnJobFailureSub 	= Sub to call on JobFailure
'Module 			= Me
Public Sub ExecuteScript(Script As String, OnJobSuccessSub As String, OnJobFailureSub As String, Module As Object)
	Dim MySQLJob As HttpJob
	Dim strPost As String
	Dim su As StringUtils
		
	If cHashKey.Trim <> "" Then	
		'EnCrypt
		strPost = "host="       & su.EncodeUrl(Encrypt(MySQLConnection.Host), "UTF8")
		If MySQLConnection.Port <> "" 		Then strPost = strPost & "&port="      & su.EncodeUrl(Encrypt(MySQLConnection.Port), "UTF8")
		If MySQLConnection.Charset <> "" 	Then strPost = strPost & "&charset="   & su.EncodeUrl(Encrypt(MySQLConnection.Charset), "UTF8")
		If MySQLConnection.DataBase <> "" 	Then strPost = strPost & "&dbname="    & su.EncodeUrl(Encrypt(MySQLConnection.DataBase), "UTF8")
		If MySQLConnection.UserName <> ""	Then strPost = strPost & "&username="  & su.EncodeUrl(Encrypt(MySQLConnection.UserName), "UTF8")
		If MySQLConnection.Password <> ""	Then strPost = strPost & "&password="  & su.EncodeUrl(Encrypt(MySQLConnection.Password), "UTF8")
		If Script <> "" 					Then strPost = strPost & "&query=" 	   & su.EncodeUrl(Encrypt(Script), "UTF8")
		strPost = strPost & "&compress="  & su.EncodeUrl(Encrypt(MySQLConnection.Compress), "UTF8") & _
				  			"&encrypted=1"
	Else
		strPost = "host="       & su.EncodeUrl(MySQLConnection.Host, "UTF8")
		If MySQLConnection.Port <> "" 		Then strPost = strPost & "&port="      & su.EncodeUrl(MySQLConnection.Port, "UTF8")
		If MySQLConnection.Charset <> "" 	Then strPost = strPost & "&charset="   & su.EncodeUrl(MySQLConnection.Charset, "UTF8")
		If MySQLConnection.DataBase <> "" 	Then strPost = strPost & "&dbname="    & su.EncodeUrl(MySQLConnection.DataBase, "UTF8")
		If MySQLConnection.UserName <> ""	Then strPost = strPost & "&username="  & su.EncodeUrl(MySQLConnection.UserName, "UTF8")
		If MySQLConnection.Password <> ""	Then strPost = strPost & "&password="  & su.EncodeUrl(MySQLConnection.Password, "UTF8")
		If Script <> "" 					Then strPost = strPost & "&query=" 	   & su.EncodeUrl(Script , "UTF8")
		strPost = strPost & "&compress="  & su.EncodeUrl(MySQLConnection.Compress, "UTF8")
	End If
		  
	If (OnJobSuccessSub <> Null AND OnJobSuccessSub.Trim <> "") OR (OnJobFailureSub <> Null AND OnJobFailureSub.Trim <> "") Then
		Dim Action As typMySQLConnectionAction
		Action.Initialize
		Action.ActionName = OnJobSuccessSub & "_" & OnJobFailureSub 
		Action.Module = Module
		Action.OnJobSuccessSub = OnJobSuccessSub
		Action.OnJobFailureSub = OnJobFailureSub 
		
		Dim rmAction As typMySQLConnectionAction
		For i = 0 To Actions.Size - 1
			rmAction = Actions.get(i)
			If rmAction.ActionName = Action.ActionName Then	Actions.RemoveAt(i)
		Next
		
		Actions.Add(Action)
	End If	
			  
	Log(strPost)
		
	MySQLJob.Initialize(OnJobSuccessSub & "_" & OnJobFailureSub, Me)
	MySQLJob.PostString(MySQLConnection.HTTPTunnel, strPost)
End Sub

Private Sub JobDone(Job As HttpJob)
	Dim Action As typMySQLConnectionAction
	Dim i As Long
	Dim bFound As Boolean

	bFound = False
	Action.Initialize
	For i = 0 To Actions.Size - 1
		Action = Actions.get(i)
		If Job.JobName = Action.ActionName Then
			Actions.RemoveAt(i)
			bFound = True
			Exit
		End If
	Next

	If Job.Success Then
		Dim strResult As String
										
		If MySQLConnection.Compress = 1 Then
			Dim cs As CompressedStreams	
			Dim su As StringUtils
			Dim bt() As Byte
			Dim bc As ByteConverter

			bt = su.DecodeBase64(Job.GetString)
			bt = cs.DecompressBytes(bt, "zlib") ' change to gzip next
			strResult = bc.StringFromBytes(bt, "UTF8")
		Else
			strResult = Job.GetString
		End If
		
		If cHashKey.Trim <> "" Then	'DeCrypt
			strResult = Decrypt(strResult)
		End If
	
		If bFound AND SubExists(Action.Module, Action.OnJobSuccessSub) Then CallSub3(Action.Module, Action.OnJobSuccessSub, strResult, Me)
	Else
        Log("HTTP Request Error: " & Job.ErrorMessage)
		If bFound AND SubExists(Action.Module, Action.OnJobFailureSub) Then CallSub3(Action.Module, Action.OnJobFailureSub, Job.ErrorMessage, Me)
	End If
	Job.Release
End Sub

'Returns the Connection Host
Sub getHost As String
	Return	MySQLConnection.Host
End Sub

'Returns the Connection Database
Sub getDatabase As String
	Return	MySQLConnection.DataBase
End Sub

'Returns the Connection UserName
Sub getUserName As String
	Return	MySQLConnection.UserName
End Sub

'Returns the Connection Password
Sub getPassword As String
	Return	MySQLConnection.Password
End Sub

'Returns the Connection Charset
Sub getCharset As String
	Return	MySQLConnection.Charset
End Sub

'Returns the Connection Port
Sub getPort As String
	Return	MySQLConnection.Port
End Sub
