﻿Type=Class
Version=2.71
@EndOfDesignText@
'ClsDBMySQLDataset v1.4
'Basic4Android v2.70 Class
'Developed by QUALISYS SOFTWARE

'Class module
Sub Class_Globals
	Type typeDataSet(TunnelVersion, ServerVersion, Query, ErrorNumber, ErrorDescr, RowsAffected, LastInsert_ID, FieldCount As String, FieldsDescr As List, Rows As List, Params As List,PrefixIndex As Map, SubstringIndex As Map)
'	Type typParamParse(Name As String, IndexStart, IndexEnd As Long)
	Type typKeyFieldExtract(KeyField As String, IndexEnd As Long)
	Type typBookmark(RecordNumber As Long, GUID As Object)
	Type typDBAwareAction(Module As Object)
'	Type typIndex(RecordNumber As Long, IndexData As Object)

	Private DBMySQLConnection As ClsDBMySQLConnection
	Private DBMySQLUtilsModule As Object
	Public  SQL 			As ClsDBSQLScript
	Public  SQLDelete 		As ClsDBSQLScript
	Public  SQLInsert 		As ClsDBSQLScript
	Public  SQLUpdate 		As ClsDBSQLScript
	Public  SQLRefresh 		As ClsDBSQLScript
	'Public  SQLLock 		As ClsDBSQLScript
	Private Dataset 		As typeDataSet
	Private RecordNumber 	As Long
	Private NullValue       As String : NullValue = Chr(0)
	'Private EncodedB64Value As String : NullValue = Chr(1)
	Private intState        As Long
	Private bInsertOrUpdate As Boolean
	Private DBAwareEvents   As List
'	Private strFilter       As String
'	Private bFiltered       As Boolean
'	Private iFilterOptions  As Int
	Private MIN_LIMIT 		As Int = 1
	Private MAX_LIMIT 		As Int = 4 'doesn't limit the words length. Only the index.	
	Dim cIndexField As ClsDBField
	
	'Tag
	Public Tag As Object
	
	'JSONDecoding Events
	Public OnErrorDecoding As String
	
	'Execute Events
	Public OnBeforeExecute As String
	Public OnAfterExecute As String
	Public OnErrorExecute As String	
	
	'Insert Events
	Public OnBeforeInsert As String
	Public OnAfterInsert As String	

	'Edit Events
	Public OnBeforeEdit As String
	Public OnAfterEdit As String	

	'Post Events
	Public OnBeforePost As String
	Public OnAfterPost As String
	Public OnErrorPost As String	

	'Delete Events
	Public OnBeforeDelete As String
	Public OnAfterDelete As String
	Public OnErrorDelete As String	

	'Refresh Events
	Public OnBeforeRefresh As String
	Public OnAfterRefresh As String
	Public OnErrorRefresh As String	

	'Cancel Events
	Public OnBeforeCancel As String
	Public OnAfterCancel As String	
	
	'Scroll Events
	Public OnBeforeScroll As String
	Public OnAfterScroll As String		
End Sub

'Initializes ClsDBMySQLDataset.
'MySQLConnection = MySQLConnection AS typMySQLConnection
'Module          = Me
Public Sub Initialize(MySQLConnection As ClsDBMySQLConnection, Module As Object)
	DBMySQLConnection = MySQLConnection
	DBMySQLUtilsModule = Module
	Dataset.Initialize
	Dataset.FieldsDescr.Initialize
	Dataset.Rows.Initialize
	Dataset.Params.Initialize
	Dataset.PrefixIndex.Initialize
	Dataset.SubstringIndex.Initialize
	
	SQL.Initialize(Me)
	SQLDelete.Initialize(Me)
	SQLInsert.Initialize(Me)
	SQLUpdate.Initialize(Me)
	SQLRefresh.Initialize(Me)
	'SQLLock.Initialize(Me)
	intState = CodDB.dsInactive
	
	DBAwareEvents.Initialize
End Sub

Sub getModule As Object
	Return DBMySQLUtilsModule
End Sub

'Change the module that holds the events to be called
'Module			= Me
Sub setModule(Module As Object)
	DBMySQLUtilsModule = Module
End Sub

Private Sub ParseSQL(strIntSQL As String, bParseOld As Boolean, bParseFields As Boolean, bParseParams As Boolean) As String
	Dim sParam As String
	Dim paramParse As typParamParse	
	Dim DBParameter As ClsDBParameter
	Dim DBField As ClsDBField
	Dim mResult, mParams, mParam As Map
	
	mResult.Initialize
	mParams.Initialize

	paramParse.Initialize
	paramParse = ParseStringForParam(strIntSQL, paramParse.indexstart)
	Do While paramParse.Name <> ""
		mParam.Initialize
   	    'Parse Old Field Values
		If bParseOld AND paramParse.Name.ToUpperCase.StartsWith("OLD_") Then
			paramParse.Name = paramParse.Name.SubString2(4, paramParse.Name.Length)
			DBField = FieldByName(paramParse.Name)
			If DBField <> Null Then
				If DBField.Value = Null Then
					sParam = "NULL"
				Else			
					Select DBField.FieldType
						Case CodDB.ftVARCHAR, CodDB.ftCHAR, CodDB.ftUNKNWOWN
							sParam = DBField.OriginalStringValueAsBase64
							mParam.Put("addsinglequotes", "true")
							mParam.Put("encoding", "base64")
						Case CodDB.ftSMALLINT, CodDB.ftTINYINT, CodDB.ftINT, CodDB.ftFLOAT, CodDB.ftDOUBLE, CodDB.ftBIT, CodDB.ftBIGINT, CodDB.ftMEDIUMINT, CodDB.ftYEAR  
							sParam = DBField.OriginalValue
						Case CodDB.ftTIMESTAMP, CodDB.ftDATE, CodDB.ftTIME, CodDB.ftDATETIME
							Dim dt As Long = DBField.OriginalValue
							Dim day As Int  = DateTime.GetDayOfMonth(dt)
							Dim month As Int = DateTime.GetMonth(dt)
							Dim year As Int = DateTime.GetYear(dt)
							Dim hour As Int = DateTime.GetHour(dt)
							Dim minute As Int = DateTime.GetMinute(dt)
							Dim second As Int= DateTime.GetSecond(dt)
							sParam = "STR_TO_DATE('" & year & "-" & month & "-" & day & " " & hour & ":" & minute & ":" & second & "', '%Y-%m-%d %H:%i:%s')"
						Case CodDB.ftBLOB, CodDB.ftLONGBLOB, CodDB.ftMEDIUMBLOB, CodDB.ftTINYBLOB
							sParam = DBField.OriginalStringValueAsBase64
							mParam.Put("addsinglequotes", "true")
							mParam.Put("encoding", "base64")
						Case CodDB.ftBOOLEAN
							sParam = DBField.OriginalValue
						Case CodDB.ftENUM, CodDB.ftSET, CodDB.ftGEOMETRY
							sParam = "'" & DBField.OriginalValue & "'"
						Case Else
							sParam = DBField.OriginalStringValueAsBase64
							mParam.Put("addsinglequotes", "true")
							mParam.Put("encoding", "base64")
					End Select
				End If
				
				'strIntSQL = strIntSQL.SubString2(0, paramParse.indexstart) & sParam & strIntSQL.SubString2(paramParse.IndexEnd, strIntSQL.Length)
				mParam.Put("value", sParam)
				mParams.Put("Old_" & DBField.Name, mParam)
			End If
		Else 
			Dim bFound As Boolean = False
			If bParseFields Then
			   	'Parse Field Values
				DBField = FieldByName(paramParse.Name)
				If DBField <> Null Then
					If DBField.Value = Null Then
						sParam = "NULL"
					Else
						Select DBField.FieldType
							Case CodDB.ftVARCHAR, CodDB.ftCHAR, CodDB.ftUNKNWOWN
								sParam = DBField.StringValueAsBase64
								mParam.Put("addsinglequotes", "true")
								mParam.Put("encoding", "base64")
							Case CodDB.ftSMALLINT, CodDB.ftTINYINT, CodDB.ftINT, CodDB.ftFLOAT, CodDB.ftDOUBLE, CodDB.ftBIT, CodDB.ftBIGINT, CodDB.ftMEDIUMINT, CodDB.ftYEAR  
								sParam = DBField.Value
							Case CodDB.ftTIMESTAMP, CodDB.ftDATE, CodDB.ftTIME, CodDB.ftDATETIME
								Dim dt As Long = DBField.AsDateTime
								Dim day As Int = DateTime.GetDayOfMonth(dt)
								Dim month As Int = DateTime.GetMonth(dt)
								Dim year As Int = DateTime.GetYear(dt)
								Dim hour As Int = DateTime.GetHour(dt)
								Dim minute As Int= DateTime.GetMinute(dt)
								Dim second As Int= DateTime.GetSecond(dt)
								sParam = "STR_TO_DATE('" & year & "-" & month & "-" & day & " " & hour & ":" & minute & ":" & second & "', '%Y-%m-%d %H:%i:%s')"
							Case CodDB.ftBLOB, CodDB.ftLONGBLOB, CodDB.ftMEDIUMBLOB, CodDB.ftTINYBLOB
								sParam = DBField.StringValueAsBase64
								mParam.Put("addsinglequotes", "true")
								mParam.Put("encoding", "base64")
							Case CodDB.ftBOOLEAN
								sParam = DBField.Value
							Case CodDB.ftENUM, CodDB.ftSET, CodDB.ftGEOMETRY
								sParam = "'" & DBField.Value & "'"
							Case Else
								sParam = DBField.StringValueAsBase64
								mParam.Put("addsinglequotes", "true")
								mParam.Put("encoding", "base64")
						End Select
					End If
					bFound = True
					'strIntSQL = strIntSQL.SubString2(0, paramParse.indexstart) & sParam & strIntSQL.SubString2(paramParse.IndexEnd, strIntSQL.Length)
					mParam.Put("value", sParam)
					mParams.Put(DBField.Name, mParam)
				End If
			End If
			If Not(bFound) AND bParseParams Then
				'Parse Parameters
				DBParameter = ParamByName(paramParse.Name)
				If DBParameter <> Null Then
					If DBParameter.Value = Null Then
						sParam = "NULL"
					Else			
						Select DBParameter.ParamType
							Case CodDB.ftVARCHAR, CodDB.ftCHAR, CodDB.ftUNKNWOWN
								sParam = DBParameter.StringValueAsBase64
								mParam.Put("addsinglequotes", "true")
								mParam.Put("encoding", "base64")
							Case CodDB.ftSMALLINT, CodDB.ftTINYINT, CodDB.ftINT, CodDB.ftFLOAT, CodDB.ftDOUBLE, CodDB.ftBIT, CodDB.ftBIGINT, CodDB.ftMEDIUMINT, CodDB.ftYEAR  
								sParam = DBParameter.Value
							Case CodDB.ftTIMESTAMP, CodDB.ftDATE, CodDB.ftTIME, CodDB.ftDATETIME
								Dim dt As Long = DBField.AsDateTime
								Dim day As Int = DateTime.GetDayOfMonth(dt)
								Dim month As Int = DateTime.GetMonth(dt)
								Dim year As Int = DateTime.GetYear(dt)
								Dim hour As Int = DateTime.GetHour(dt)
								Dim minute As Int = DateTime.GetMinute(dt)
								Dim second As Int = DateTime.GetSecond(dt)
								sParam = "STR_TO_DATE('" & year & "-" & month & "-" & day & " " & hour & ":" & minute & ":" & second & "', '%Y-%m-%d %H:%i:%s')"
							Case CodDB.ftBLOB, CodDB.ftLONGBLOB, CodDB.ftMEDIUMBLOB, CodDB.ftTINYBLOB
								sParam = DBParameter.StringValueAsBase64
								mParam.Put("addsinglequotes", "true")
								mParam.Put("encoding", "base64")
							Case CodDB.ftBOOLEAN
								sParam = DBParameter.Value
							Case CodDB.ftENUM, CodDB.ftSET, CodDB.ftGEOMETRY
								sParam = "'" & DBParameter.Value & "'"
							Case Else
								sParam = DBParameter.StringValueAsBase64
								mParam.Put("addsinglequotes", "true")
								mParam.Put("encoding", "base64")
						End Select
					End If
					
					'strIntSQL = strIntSQL.SubString2(0, paramParse.indexstart) & sParam & strIntSQL.SubString2(paramParse.IndexEnd, strIntSQL.Length)
					mParam.Put("value", sParam)
					mParams.Put(DBParameter.Name, mParam)
				End If
			End If
		End If
		
		paramParse = ParseStringForParam(strIntSQL, paramParse.IndexEnd)
	Loop
	
	mResult.Put("SQL", strIntSQL)
	mResult.Put("params", mParams)
	Dim JSONGenerator As JSONGenerator
	
	JSONGenerator.Initialize(mResult)
		
	Return JSONGenerator.ToString
End Sub


'Execute The SQL Query. Return True on success, False otherwise. You might want to check the dataset's state before executing.
Public Sub Execute As Boolean
	Dim sSQLParsed As String
	Dim Ex As ExceptionEx
	
	If State <> CodDB.dsInactive AND State <> CodDB.dsBrowse AND State <> CodDB.dsOpening Then
		Ex.Initialize(CodDB.SDataSetNotBrowse)
		Ex.Throw
	End If	
	
	If State = CodDB.dsOpening Then Log("Dataset already in dsOpening mode. Maybe a duplicate execute")
	
	If SQL.ToString.Trim = ""  Then
		Ex.Initialize(CodDB.SDataSetNoSQLScript)
		Ex.Throw
	End If	
		
	If SubExists(DBMySQLUtilsModule, OnBeforeExecute) Then CallSub2(DBMySQLUtilsModule, OnBeforeExecute, Me)
	intState = CodDB.dsOpening

	'Parse Parameters to Values
	sSQLParsed = ParseSQL(SQL.ToString, False, False, True)
	
	DBMySQLConnection.ExecuteScript(sSQLParsed, "JobExecute_Done", "JobExecute_Failure", Me)
	Return True
End Sub

Private Sub JobExecute_Done(Result As String, cDBMySQLConnection As ClsDBMySQLConnection)
	Dim bDecoded As Boolean = JSONDecodeHeaders(Result)
	If bDecoded Then bDecoded = JSONDecodeRows(Result)
	If Not(bDecoded) Then			
		intState = CodDB.dsInactive
		If SubExists(DBMySQLUtilsModule, OnErrorDecoding) Then 
			CallSub3(DBMySQLUtilsModule, OnErrorDecoding, Result, Me)
		Else
			Dim Ex As ExceptionEx
			
			Ex.Initialize(CodDB.SDecodeError)
			Ex.Throw
		End If
	Else If	Dataset.ErrorNumber <> 0 Then
		intState = CodDB.dsInactive
		If SubExists(DBMySQLUtilsModule, OnErrorExecute) Then 
			CallSub3(DBMySQLUtilsModule, OnErrorExecute, Dataset.ErrorDescr, Me)
		Else
			Dim Ex As ExceptionEx
			
			Ex.Initialize(CodDB.SExecuteError)
			Ex.Throw			
		End If
	Else
		intState = CodDB.dsBrowse
		If SubExists(DBMySQLUtilsModule, OnAfterExecute) Then 
			CallSub2(DBMySQLUtilsModule, OnAfterExecute, Me)
		End If
	End If	
End Sub

Private Sub JobExecute_Failure(ErrorMessage As String, cDBMySQLConnection As ClsDBMySQLConnection)
	intState = CodDB.dsInactive
    Log("HTTP Request Error: " & ErrorMessage)
	If SubExists(DBMySQLUtilsModule, OnErrorExecute) Then CallSub3(DBMySQLUtilsModule, OnErrorExecute, ErrorMessage, Me)
End Sub

'Execute The SQLRefresh Query. Return True on success, False otherwise. You might want to check the dataset's state before executing.
Public Sub RecordRefresh As Boolean
	Dim sSQLParsed As String
	Dim Ex As ExceptionEx
	
	CheckBrowse

	If SQLRefresh.ToString.Trim = ""  Then
		Ex.Initialize(CodDB.SDataSetNoSQLScript)
		Ex.Throw
	End If	
		
	If SubExists(DBMySQLUtilsModule, OnBeforeRefresh) Then CallSub2(DBMySQLUtilsModule, OnBeforeRefresh, Me)
	intState = CodDB.dsOpening

	'Parse Parameters to Values
	sSQLParsed = ParseSQL(SQLRefresh.ToString, True, False, True)
	
	DBMySQLConnection.ExecuteScript(sSQLParsed, "JobRefresh_Done", "JobRefresh_Failure", Me)
	Return True
End Sub

Private Sub JobRefresh_Done(Result As String, cDBMySQLConnection As ClsDBMySQLConnection)
	Dim bDecoded As Boolean = JSONDecodeHeaders(Result)
	If bDecoded Then bDecoded = JSONDecodeSingleRow(Result)
	If Not(bDecoded) Then			
		intState = CodDB.dsInactive
		If SubExists(DBMySQLUtilsModule, OnErrorDecoding) Then 
			CallSub3(DBMySQLUtilsModule, OnErrorDecoding, Result, Me)
		Else
			Dim Ex As ExceptionEx
			
			Ex.Initialize(CodDB.SDecodeError)
			Ex.Throw			
		End If
	Else If	Dataset.ErrorNumber <> 0 Then
		intState = CodDB.dsBrowse
		If SubExists(DBMySQLUtilsModule, OnErrorRefresh) Then 
			CallSub3(DBMySQLUtilsModule, OnErrorRefresh, Dataset.ErrorDescr, Me)
		Else
			Dim Ex As ExceptionEx
			
			Ex.Initialize(CodDB.SRefreshError)
			Ex.Throw			
		End If
	Else
		intState = CodDB.dsBrowse
		If SubExists(DBMySQLUtilsModule, OnAfterRefresh) Then 
			CallSub2(DBMySQLUtilsModule, OnAfterRefresh, Me)
		End If
	End If	
End Sub

Private Sub JobRefresh_Failure(ErrorMessage As String, cDBMySQLConnection As ClsDBMySQLConnection)
	intState = CodDB.dsInactive
    Log("HTTP Request Error: " & ErrorMessage)
	If SubExists(DBMySQLUtilsModule, OnErrorRefresh) Then CallSub3(DBMySQLUtilsModule, OnErrorRefresh, ErrorMessage, Me)
End Sub

'Adds a new, empty record to the end of the dataset. You might want to check the dataset's state before executing.
Sub Append As Boolean
	Dim result As Boolean
	
	CheckBrowse

	If SubExists(DBMySQLUtilsModule, OnBeforeInsert) Then CallSub2(DBMySQLUtilsModule, OnBeforeInsert, Me)
	result = InsertBuffer(False)
	If result Then
		intState = CodDB.dsInsert
		If SubExists(DBMySQLUtilsModule, OnAfterInsert) Then CallSub2(DBMySQLUtilsModule, OnAfterInsert, Me)
	End If
	
	Return result
End Sub

'Inserts a new, empty record In the Dataset. You might want to check the dataset's state before executing.
Sub Insert As Boolean
	Dim result As Boolean
	
	CheckBrowse

	If SubExists(DBMySQLUtilsModule, OnBeforeInsert) Then CallSub2(DBMySQLUtilsModule, OnBeforeInsert, Me)	
	result = InsertBuffer(True)
	If result Then
		intState = CodDB.dsInsert
		If SubExists(DBMySQLUtilsModule, OnAfterInsert) Then CallSub2(DBMySQLUtilsModule, OnAfterInsert, Me)
	End If
	
	Return result
End Sub

'Enables editing of data in the dataset. You might want to check the dataset's state before executing.
Sub Edit As Boolean

	CheckBrowse
	
	If SubExists(DBMySQLUtilsModule, OnBeforeEdit) Then CallSub2(DBMySQLUtilsModule, OnBeforeEdit, Me)
	intState = CodDB.dsEdit
	If SubExists(DBMySQLUtilsModule, OnAfterEdit) Then CallSub2(DBMySQLUtilsModule, OnAfterEdit, Me)	
	
	Return True
End Sub

'Cancels modifications to the active record if those changes are not yet posted. You might want to check the dataset's state before executing.
Sub Cancel As Boolean
	Dim result As Boolean
	
	CheckActive

	If SubExists(DBMySQLUtilsModule, OnBeforeCancel) Then CallSub2(DBMySQLUtilsModule, OnBeforeCancel, Me)
	If State = CodDB.dsInsert Then
		Dataset.Rows.RemoveAt(RecordNumber - 1)
		RecordNumber = RecordNumber - 1
		If RecordNumber < 1 Then RecordNumber = 1
	End If
	result = UpdateBuffer
	If result Then
		intState = CodDB.dsBrowse
		If SubExists(DBMySQLUtilsModule, OnAfterCancel) Then CallSub2(DBMySQLUtilsModule, OnAfterCancel, Me)
	End If
	
	Return result
End Sub

'Write a modified record to the database. You might want to check the dataset's state before executing.
Sub Post As Boolean
	Dim sSQLParsed As String
	Dim Ex As ExceptionEx

	CheckInsertOtEdit
	
	If ((State = CodDB.dsInsert) AND (SQLInsert.ToString.Trim = "")) OR ((State = CodDB.dsEdit) AND (SQLUpdate.ToString.Trim = "")) Then
		Ex.Initialize(CodDB.SDataSetNoSQLScript)
		Ex.Throw
	End If	
	
	If SubExists(DBMySQLUtilsModule, OnBeforePost) Then CallSub2(DBMySQLUtilsModule, OnBeforePost, Me)		
	'Parse Parameters to Values
	If State = CodDB.dsInsert Then
		sSQLParsed = ParseSQL(SQLInsert.ToString, False, True, True)
		bInsertOrUpdate = True
	Else
		sSQLParsed = ParseSQL(SQLUpdate.ToString, True, True, True)
		bInsertOrUpdate = False
	End If
	
	intState = CodDB.dsPosting

	DBMySQLConnection.ExecuteScript(sSQLParsed, "JobPost_Done", "JobPost_Failure", Me)
	Return True
End Sub

Private Sub JobPost_Done(Result As String, cDBMySQLConnection As ClsDBMySQLConnection)
	Dim bDecoded As Boolean = JSONDecodeHeaders(Result)
	If Not(bDecoded) Then			
		intState = CodDB.dsBrowse
		If SubExists(DBMySQLUtilsModule, OnErrorDecoding) Then 
			CallSub3(DBMySQLUtilsModule, OnErrorDecoding, Result, Me)
		Else
			Dim Ex As ExceptionEx
			
			Ex.Initialize(CodDB.SDecodeError)
			Ex.Throw			
		End If
	Else If	Dataset.ErrorNumber <> 0 Then
		intState = CodDB.dsBrowse
		If SubExists(DBMySQLUtilsModule, OnErrorPost) Then 
			CallSub3(DBMySQLUtilsModule, OnErrorPost, Dataset.ErrorDescr, Me)
		Else
			Dim Ex As ExceptionEx
			If bInsertOrUpdate Then
				Ex.Initialize(CodDB.SInsertError)
			Else
				Ex.Initialize(CodDB.SUpdateError)
			End If
			Ex.Throw						
		End If
	Else
		If Dataset.LastInsert_ID <> "" AND IsNumber(Dataset.LastInsert_ID) AND Dataset.LastInsert_ID > 0 Then
			Dim i As Long
			Dim iPrevintState As Long = intState
			intState = CodDB.dsInsert
			Dim iAutoNumber As Long = Dataset.LastInsert_ID
			For i = 0 To FieldCount - 1
				If Fields(i).AutoIncrement Then
					Fields(i).OriginalValue = iAutoNumber
					Exit
				End If
			Next
			intState = iPrevintState
		End If

		intState = CodDB.dsBrowse
		UpdateRow
		If SubExists(DBMySQLUtilsModule, OnAfterPost) Then 
			CallSub2(DBMySQLUtilsModule, OnAfterPost, Me)
		End If
	End If	
End Sub

Private Sub JobPost_Failure(ErrorMessage As String, cDBMySQLConnection As ClsDBMySQLConnection)
	intState = CodDB.dsInactive
    Log("HTTP Request Error: " & ErrorMessage)
	If SubExists(DBMySQLUtilsModule, OnErrorPost) Then CallSub3(DBMySQLUtilsModule, OnErrorPost, ErrorMessage, Me)
End Sub

'Delete current record from the database. You might want to check the dataset's state before executing.
Sub Delete As Boolean
	Dim sSQLParsed As String
	Dim Ex As ExceptionEx
	
	CheckBrowse

	If (SQLDelete.ToString.Trim = "") Then
		Ex.Initialize(CodDB.SDataSetNoSQLScript)
		Ex.Throw
	End If	
	
	If SubExists(DBMySQLUtilsModule, OnBeforeDelete) Then CallSub2(DBMySQLUtilsModule, OnBeforeDelete, Me)
	
	'Parse Parameters to Values
	sSQLParsed = ParseSQL(SQLDelete.ToString, True, False, True)
	
	intState = CodDB.dsDeleting
	
	DBMySQLConnection.ExecuteScript(sSQLParsed, "JobDelete_Done", "JobDelete_Failure", Me)
	Return True
End Sub

Private Sub JobDelete_Done(Result As String, cDBMySQLConnection As ClsDBMySQLConnection)
	Dim bDecoded As Boolean = JSONDecodeHeaders(Result)
	If Not(bDecoded) Then			
		intState = CodDB.dsBrowse
		If SubExists(DBMySQLUtilsModule, OnErrorDecoding) Then 
			CallSub3(DBMySQLUtilsModule, OnErrorDecoding, Result, Me)
		Else
			Dim Ex As ExceptionEx
			
			Ex.Initialize(CodDB.SDecodeError)
			Ex.Throw			
		End If
	Else If	Dataset.ErrorNumber <> 0 Then
		intState = CodDB.dsBrowse
		If SubExists(DBMySQLUtilsModule, OnErrorDelete) Then 
			CallSub3(DBMySQLUtilsModule, OnErrorDelete, Dataset.ErrorDescr, Me)
		Else
			Dim Ex As ExceptionEx
			
			Ex.Initialize(CodDB.SDeleteError)
			Ex.Throw						
		End If
	Else
		intState = CodDB.dsBrowse
		DeleteRow
		If SubExists(DBMySQLUtilsModule, OnAfterDelete) Then 
			CallSub2(DBMySQLUtilsModule, OnAfterDelete, Me)
		End If
	End If	
End Sub

Private Sub JobDelete_Failure(ErrorMessage As String, cDBMySQLConnection As ClsDBMySQLConnection)
	intState = CodDB.dsInactive
    Log("HTTP Request Error: " & ErrorMessage)
	If SubExists(DBMySQLUtilsModule, OnErrorDelete) Then CallSub3(DBMySQLUtilsModule, OnErrorDelete, ErrorMessage, Me)
End Sub

Private Sub JSONDecodeHeaders(strResponse As String) As Boolean
	Dim jsonResponse As JSONParser
	Dim mapResult As Map
	
	jsonResponse.Initialize(strResponse)
	mapResult = jsonResponse.NextObject
	
	Dataset.TunnelVersion 	= mapResult.get("tunnelversion")
	Dataset.ServerVersion 	= mapResult.get("serverversion")
	Dataset.Query 			= mapResult.get("query")
	Dataset.ErrorNumber 	= mapResult.get("errornumber")
	Dataset.ErrorDescr 		= mapResult.get("errordescr")
	Dataset.RowsAffected	= mapResult.get("affectedrows")
	Dataset.LastInsert_ID	= mapResult.get("lastinsert_id")
	Return True
End Sub

Private Sub JSONDecodeRows(strResponse As String) As Boolean
	Dim jsonResponse As JSONParser
	Dim mapResult As Map
	Dim lstFieldDescr, lstRows As List
	Dim sNull As String
	Dim i As Long
	
	'Initialize Record Pointer
	RecordNumber = 0
	
	jsonResponse.Initialize(strResponse)
	mapResult = jsonResponse.NextObject
	
	'Fields Descriptions
	Dataset.FieldsDescr.Initialize
	'Rows
	Dataset.Rows.Initialize
	Dataset.PrefixIndex.Initialize
	Dataset.SubstringIndex.Initialize
	lstRows.Initialize
		
	Dataset.FieldCount	= mapResult.get("fieldcount")
	If Dataset.FieldCount > 0 Then
		lstFieldDescr = mapResult.get("fieldsdescr")
		If Dataset.FieldCount <> lstFieldDescr.Size Then 
			Dim Ex As ExceptionEx

			Ex.Initialize(CodDB.SIncorrectResultSet)
			Ex.Throw
		End If
		For i = 0 To lstFieldDescr.Size - 1
			Dim DBField As ClsDBField
			Dim mapFieldDescr As Map

			mapFieldDescr = lstFieldDescr.get(i)
			'DBField = FieldByName(mapFieldDescr.get("name"))
			'If DBField = Null OR Not(DBField.IsInitialized) Then
				Dim DBField As ClsDBField
				DBField.Initialize(Me)	
				DBField.Table = mapFieldDescr.get("table")
				DBField.OriginalTable = mapFieldDescr.get("orgtable")
				DBField.Name = mapFieldDescr.get("name")
				DBField.OriginalName = mapFieldDescr.get("orgname")
				DBField.MaxLength = mapFieldDescr.get("maxlength")
				If IsNumber(mapFieldDescr.get("minvalue")) Then
					DBField.MinValue = mapFieldDescr.get("minvalue")
				Else
					DBField.MinValue = 0
				End If
				If IsNumber(mapFieldDescr.get("maxvalue")) Then
					DBField.MaxValue = mapFieldDescr.get("maxvalue")
				Else
					DBField.MaxValue = 0
				End If
				DBField.FieldType = mapFieldDescr.get("type")
				If mapFieldDescr.get("notnull") = "1" Then
					DBField.Required = True
				Else
					DBField.Required = False
				End If
				
				If mapFieldDescr.get("uniquekey") = "1" Then
					DBField.UniqueKey = True
				Else
					DBField.UniqueKey = False
				End If
				
				If mapFieldDescr.get("autoincrement") = "1" Then
					DBField.AutoIncrement = True
				Else
					DBField.AutoIncrement = False
				End If
				
				DBField.Index = i
				Dataset.FieldsDescr.Add(DBField)				
			'End If
				
			If IsNumber(mapFieldDescr.get("length")) Then
				DBField.Length = mapFieldDescr.get("length")
			Else
				DBField.Length = 0
			End If
								
			Dim DBParameter As ClsDBParameter
			DBParameter = ParamByName(DBField.Name)
			If DBParameter <> Null Then
				DBParameter.ParamType = DBField.FieldType
			End If
		Next
	
		If mapResult.get("rows") <> "" Then
			lstRows = mapResult.get("rows")
		End If
		For i = 0 To lstRows.Size - 1
			Dim lstRow As List
			Dim mapRow As Map
			Dim J As Long

			lstRow = lstRows.get(i)
			If lstRow.Size <> Dataset.FieldCount Then
				Dim Ex As ExceptionEx
	
				Ex.Initialize(CodDB.SIncorrectResultSet)
				Ex.Throw
			End If
			
			Dim row(lstRow.Size + 1) As Object
			For J = 0 To lstRow.Size - 1					
				mapRow = lstRow.get(J)
				sNull = mapRow.GetValueAt(0)
				If sNull.Length = NullValue.Length AND sNull.CharAt(0) = NullValue.CharAt(0) Then
					row(J) = Null
				Else
					row(J) = mapRow.GetValueAt(0)
				End If
			Next
			row(lstRow.Size) = getGUID
			
			Dataset.Rows.Add(row)
		Next
		
		'Move to first row
		If lstRows.Size > 0 Then
			RecordNumber = 1
		Else
			RecordNumber = -1
		End If
		UpdateBuffer
	End If

	Return True
End Sub

Private Sub JSONDecodeSingleRow(strResponse As String) As Boolean
	Dim jsonResponse As JSONParser
	Dim mapResult As Map
	Dim lstFieldDescr, lstRows As List
	Dim sNull As String
	Dim i As Long
	
	If RecordNumber < 1 OR RecordNumber > RecordCount Then 
		Dim Ex As ExceptionEx

		Ex.Initialize(CodDB.SInvalidRecordPointer)
		Ex.Throw
	End If
	
	jsonResponse.Initialize(strResponse)
	mapResult = jsonResponse.NextObject
	lstRows.Initialize
	
	If Dataset.FieldCount <> mapResult.get("fieldcount") Then
		Dim Ex As ExceptionEx

		Ex.Initialize(CodDB.SIncorrectResultSet)
		Ex.Throw
	End If
		
	If Dataset.FieldCount > 0 Then
		lstFieldDescr = mapResult.get("fieldsdescr")
		If Dataset.FieldCount <> lstFieldDescr.Size Then 
			Dim Ex As ExceptionEx

			Ex.Initialize(CodDB.SIncorrectResultSet)
			Ex.Throw
		End If
		For i = 0 To lstFieldDescr.Size - 1
			Dim DBField As ClsDBField
			Dim mapFieldDescr As Map

			mapFieldDescr = lstFieldDescr.get(i)
			DBField = Fields(i)
			
			If DBField.Table <> mapFieldDescr.get("table") OR _
			   DBField.OriginalTable <> mapFieldDescr.get("orgtable") OR _
			   DBField.Name <> mapFieldDescr.get("name") OR _
			   DBField.OriginalName <> mapFieldDescr.get("orgname") OR _ '			   DBField.Length <> mapFieldDescr.get("length") OR _
			   DBField.FieldType <> mapFieldDescr.get("type") Then
			   
				Dim Ex As ExceptionEx

				Ex.Initialize(CodDB.SIncorrectResultSet)
				Ex.Throw
			End If
		Next
	
		If mapResult.get("rows") <> "" Then
			lstRows = mapResult.get("rows")
		End If
		If lstRows.Size <> 1 Then
			Dim Ex As ExceptionEx

			Ex.Initialize(CodDB.SResultsetNotsingle)
			Ex.Throw		
		End If
		For i = 0 To lstRows.Size - 1
			Dim lstRow As List
			Dim mapRow As Map
			Dim J As Long

			lstRow = lstRows.get(i)
			If lstRow.Size <> Dataset.FieldCount Then Return False
			Dim row(lstRow.Size + 1) As Object
			For J = 0 To lstRow.Size - 1					
				mapRow = lstRow.get(J)
				sNull = mapRow.GetValueAt(0)
				If sNull.Length = NullValue.Length AND sNull.CharAt(0) = NullValue.CharAt(0) Then
					row(J) = Null
				Else
					row(J) = mapRow.GetValueAt(0)
				End If
			Next
			row(lstRow.Size) = getGUID
			
			Dataset.Rows.Set(RecordNumber - 1, row)
		Next
	End If

	Return True
End Sub

'Indicates the total number of records associated with the dataset.
Sub RecordCount As Long
	If Dataset.IsInitialized AND Dataset.Rows.IsInitialized Then
		Return Dataset.Rows.Size
	Else
		Return 0
	End If
End Sub

'Indicates the active record in the dataset.
Sub RecNo As Long
	If Dataset.IsInitialized AND Dataset.Rows.IsInitialized Then
		Return RecordNumber
	Else
		Return -1
	End If
End Sub

'Indicates whether a dataset is positioned at the first record.
Sub BOF As Boolean
	If RecordNumber <= 1 Then
		Return True
	Else
		Return False
	End If		
End Sub

'Indicates whether a dataset is positioned at the last record.
Sub EOF As Boolean
	If RecordNumber < 0 OR RecordNumber > Dataset.Rows.Size Then
		Return True
	Else
		Return False
	End If		
End Sub

'Insert a new record to the buffer.
Private Sub InsertBuffer(InsertBeforeCurrentRecord As Boolean) As Boolean
	Dim i As Long

'	CheckBrowse
	
	If Dataset.FieldsDescr.IsInitialized AND Dataset.FieldsDescr.Size > 0 AND Dataset.Rows.IsInitialized Then
		Dim row(Dataset.FieldCount + 1) As Object
		For i = 0 To row.Length - 1
			row(i) = Null
		Next
		row(Dataset.FieldCount) = getGUID

		If InsertBeforeCurrentRecord Then
			Dataset.Rows.InsertAt(RecordNumber - 1, row)
		Else			
			Dataset.Rows.Add(row)
			RecordNumber = RecordCount
		End If		
		If UpdateBuffer Then Return True
	End If
	
	Return False
End Sub

'Update Buffer with values from Row
Private Sub UpdateBuffer As Boolean
	Dim DBField As ClsDBField
	Dim Row() As Object
	Dim i As Long
	Dim result As Boolean

'	CheckBrowse
	result = False
	intState = CodDB.dsInsert
	If Dataset.FieldsDescr.IsInitialized AND Dataset.FieldsDescr.Size > 0 AND Dataset.Rows.IsInitialized Then
		If Dataset.Rows.Size = 0 OR EOF Then
			For i = 0 To FieldCount - 1
				DBField = Fields(i)
				DBField.OriginalValue = Null
			Next
			CallDataChange
			result = True
		Else
			Row = Dataset.Rows.get(RecordNumber - 1)
			For i = 0 To FieldCount - 1
				DBField = Fields(i)
				If Row(i) = Null OR Row(i) = "" Then
					DBField.OriginalValue = Null
				Else
					Select DBField.FieldType
						Case CodDB.ftVARCHAR, CodDB.ftCHAR, CodDB.ftUNKNWOWN
							Dim sRow As String = Row(i)
							DBField.OriginalValue = sRow
						Case CodDB.ftSMALLINT, CodDB.ftTINYINT, CodDB.ftINT, CodDB.ftBIT
							Dim lRow As Long = Row(i)
							DBField.OriginalValue = lRow
						Case CodDB.ftFLOAT, CodDB.ftDOUBLE 
							Dim fRow As Double = Row(i)
							DBField.OriginalValue = fRow
						Case CodDB.ftTIMESTAMP, CodDB.ftDATE, CodDB.ftTIME, CodDB.ftDATETIME
							Dim AHdt As AHDateTime
							Dim dRow As Long
							
							AHdt.Initialize
							AHdt.Pattern = "yyyy-MM-dd HH:mm:ss"
							Try
								dRow = AHdt.Parse(Row(i))	'Try DateTime
							Catch
								AHdt.Pattern = "yyyy-MM-dd"
								Try
									dRow = AHdt.Parse(Row(i))	'Try Date
								Catch
									AHdt.Pattern = "HH:mm:ss"
									dRow = AHdt.Parse(Row(i))	'Try Time, otherwise throw the exception
								End Try
							End Try	
							DBField.OriginalValue = dRow
						Case CodDB.ftBLOB, CodDB.ftLONGBLOB, CodDB.ftMEDIUMBLOB, CodDB.ftTINYBLOB
							Dim blRow As String = Row(i)
							DBField.OriginalValue = blRow
						Case CodDB.ftBOOLEAN
							Dim bRow As Boolean
							If Row(i) = "1" Then
								bRow = True
							Else
								bRow = False
							End If
							DBField.OriginalValue = bRow
						Case CodDB.ftENUM, CodDB.ftSET, CodDB.ftGEOMETRY
							Dim sRow As String = Row(i)
							DBField.OriginalValue = sRow
						Case Else
							Dim sRow As String = Row(i)
							DBField.OriginalValue = sRow 
					End Select												
				End If
			Next
			CallDataChange
			result = True
		End If
	End If
	intState = CodDB.dsBrowse
	Return result
End Sub

'Update Row with values from Buffer
Private Sub UpdateRow As Boolean
	Dim row() As Object
	Dim i As Long

	If Dataset.FieldsDescr.IsInitialized AND Dataset.FieldsDescr.Size > 0 AND Dataset.Rows.IsInitialized AND Dataset.Rows.Size > 0 Then
		If RecordNumber > RecordCount Then
			Return False
		Else			
			Dim row(Dataset.FieldCount + 1) As Object
			For i = 0 To Dataset.FieldCount - 1
				If Fields(i).IsNull Then
					row(i) = Null
				Else
					Select Fields(i).FieldType
						Case CodDB.ftVARCHAR, CodDB.ftCHAR, CodDB.ftUNKNWOWN
							row(i) = Fields(i).AsString
						Case CodDB.ftSMALLINT, CodDB.ftTINYINT, CodDB.ftINT, CodDB.ftBIT
							row(i) = Fields(i).AsLong
						Case CodDB.ftFLOAT, CodDB.ftDOUBLE 
							row(i) = Fields(i).AsDouble
						Case CodDB.ftTIMESTAMP, CodDB.ftDATE, CodDB.ftTIME, CodDB.ftDATETIME
							row(i) = Fields(i).Value
							Dim AHdt As AHDateTime
							AHdt.Initialize
							AHdt.Pattern = "yyyy-MM-dd HH:mm:ss"
							AHdt.Format(row(i))
							row(i) = AHdt.Format(row(i))
						Case CodDB.ftBLOB, CodDB.ftLONGBLOB, CodDB.ftMEDIUMBLOB, CodDB.ftTINYBLOB
							row(i) = Fields(i).AsString
						Case CodDB.ftBOOLEAN
							If Fields(i).AsBoolean Then
								row(i) = "1"
							Else
								row(i) = "0"
							End If
						Case CodDB.ftENUM, CodDB.ftSET, CodDB.ftGEOMETRY
							row(i) = Fields(i).AsString
						Case Else
							row(i) = Fields(i).AsString
					End Select
				End If
			Next
			row(Dataset.FieldCount) = getGUID
			Dataset.Rows.Set(RecordNumber - 1, row)
		End If
	End If
	Return False
End Sub

'Delete Row from Buffer
Private Sub DeleteRow As Boolean
	If Dataset.FieldsDescr.IsInitialized AND Dataset.FieldsDescr.Size > 0 AND Dataset.Rows.IsInitialized AND Dataset.Rows.Size > 0 Then
		If EOF Then
			Return False
		Else
			Dataset.Rows.RemoveAt(RecordNumber - 1)
			Return True
		End If
	End If
	Return False
End Sub

'Moves To the first record In the Dataset. Return True on success, False otherwise. Check dataset state before executing
Public Sub FirstRecord As Boolean
	Dim result As Boolean
	
	CheckBrowse
	
	If SubExists(DBMySQLUtilsModule, OnBeforeScroll) Then CallSub2(DBMySQLUtilsModule, OnBeforeScroll, Me)

	RecordNumber = 1
	result = UpdateBuffer
	
	If result Then
		If SubExists(DBMySQLUtilsModule, OnAfterScroll) Then CallSub2(DBMySQLUtilsModule, OnAfterScroll, Me)
	End If
	Return  result
End Sub

'Moves to the next record in the dataset. Return True on success, False otherwise. Check dataset state before executing
Public Sub NextRecord As Boolean
	Dim result As Boolean

	CheckBrowse

	If SubExists(DBMySQLUtilsModule, OnBeforeScroll) Then CallSub2(DBMySQLUtilsModule, OnBeforeScroll, Me)

	RecordNumber = RecordNumber + 1
	If RecordNumber <= Dataset.Rows.Size Then
		
		result = UpdateBuffer

		If result Then
			If SubExists(DBMySQLUtilsModule, OnAfterScroll) Then CallSub2(DBMySQLUtilsModule, OnAfterScroll, Me)
		End If
	Else
		result = False
	End If
	Return  result
End Sub

'Moves to the previous record in the dataset. Return True on success, False otherwise. Check dataset state before executing
Public Sub PreviousRecord As Boolean
	Dim result As Boolean

	CheckBrowse

	If SubExists(DBMySQLUtilsModule, OnBeforeScroll) Then CallSub2(DBMySQLUtilsModule, OnBeforeScroll, Me)

	RecordNumber = RecordNumber - 1
	If RecordNumber >= 1 Then
		result = UpdateBuffer

		If result Then
			If SubExists(DBMySQLUtilsModule, OnAfterScroll) Then CallSub2(DBMySQLUtilsModule, OnAfterScroll, Me)
		End If
	Else
		result = False
	End If
	Return  result
End Sub

'Moves To the first record In the Dataset. Return True on success, False otherwise. Check dataset state before executing
Public Sub LastRecord As Boolean
	Dim result As Boolean

	CheckBrowse	

	If SubExists(DBMySQLUtilsModule, OnBeforeScroll) Then CallSub2(DBMySQLUtilsModule, OnBeforeScroll, Me)

	RecordNumber = Dataset.Rows.Size
	result = UpdateBuffer
	
	If result Then
		If SubExists(DBMySQLUtilsModule, OnAfterScroll) Then CallSub2(DBMySQLUtilsModule, OnAfterScroll, Me)
	End If
	Return  result
End Sub

'Return a Bookmark of the current record
Public Sub GetBookmark As typBookmark
	Dim Bookmark As typBookmark
	Dim Row() As Object
	
	CheckBrowse
	If RecordCount > 0 AND Not(EOF) Then
		Bookmark.RecordNumber = RecordNumber
		Row = Dataset.Rows.get(Bookmark.RecordNumber - 1)
		Bookmark.GUID = Row(FieldCount)
		Return Bookmark
	Else
		Return Null
	End If
End Sub

'Goto bookmark and sets the current record. Return True if success, False if record has been deleted. Check dataset state before executing
Public Sub GotoBookmark(Bookmark As typBookmark) As Boolean
	Dim Row() As Object
	Dim result As Boolean

	CheckBrowse
	
	If SubExists(DBMySQLUtilsModule, OnBeforeScroll) Then CallSub2(DBMySQLUtilsModule, OnBeforeScroll, Me)	
	
	result = False
	If Bookmark <> Null AND Bookmark.RecordNumber > 0 AND RecordCount > 0 AND Bookmark.RecordNumber <= RecordCount Then
		Row = Dataset.Rows.get(Bookmark.RecordNumber - 1)
		If Bookmark.GUID <>	Row(FieldCount) Then 
			Return False
		Else
			RecordNumber = Bookmark.RecordNumber
			
			result = UpdateBuffer
		End If
	Else
		Return False
	End If

	If result Then
		If SubExists(DBMySQLUtilsModule, OnAfterScroll) Then CallSub2(DBMySQLUtilsModule, OnAfterScroll, Me)	
	End If
	Return result	
End Sub

'Search the dataset for a specified record AND make it the active record. Locate does a serial search.
'Returns false, indicating that a matching record was not found and the active record was not changed. Check dataset state before executing
Public Sub Locate(KeyFields() As Object, KeyValues() As Object, loCaseInsensitive As Boolean, loPartialKey As Boolean) As Boolean
	Dim Bookmark As typBookmark
	Dim i As Long
	Dim bFound As Boolean
	Dim KeyField, KeyValue As String
	Dim result As Boolean
	
	CheckBrowse

	If SubExists(DBMySQLUtilsModule, OnBeforeScroll) Then CallSub2(DBMySQLUtilsModule, OnBeforeScroll, Me)

	result = False
	If Dataset.IsInitialized AND Dataset.Rows.IsInitialized Then
		If KeyFields.Length <> KeyValues.Length Then 'We should raise an error here
			Dim Ex As ExceptionEx
			
			Ex.Initialize(CodDB.SLocateUnequalKeyFieldsOrKeyValues)
			Ex.Throw	
		End If
		Bookmark = GetBookmark
	
		'Goto First Record
		FirstRecord
		Do While Not(EOF)
			bFound = True

			For i = 0 To KeyFields.Length - 1
				KeyField = FieldByName(KeyFields(i)).Value
				KeyValue = KeyValues(i)
				If (Not(loCaseInsensitive) AND Not(loPartialKey) AND Not(KeyField.CompareTo(KeyValue) = 0)) OR _
				   (loCaseInsensitive AND Not(loPartialKey) AND Not(KeyField.ToUpperCase.CompareTo(KeyValue.ToUpperCase) = 0)) OR _
				   (Not(loCaseInsensitive) AND loPartialKey AND Not(KeyField.Contains(KeyValue))) OR _
				   (loCaseInsensitive AND loPartialKey AND Not(KeyField.ToUpperCase.Contains(KeyValue.ToUpperCase))) Then 
					bFound = False 
					Exit
				End If
			Next
			If bFound Then Exit
			NextRecord
		Loop
		If bFound Then 
			result = UpdateBuffer
		Else If Bookmark <> Null Then 
			GotoBookmark(Bookmark)
			result = False
		End If
	Else
		Return False
	End If
	
	If result Then
		If SubExists(DBMySQLUtilsModule, OnAfterScroll) Then CallSub2(DBMySQLUtilsModule, OnAfterScroll, Me)
	End If
	Return  result
End Sub

'Builds and itnernal index based on the IndexField. Stores an object as a process global variable
'in order to avoid rebuilding the index when the device orientation changes.
Public Sub BuildIndex As Boolean
	If cIndexField = Null OR Not(cIndexField.IsInitialized) Then Return False
	
	Dim noDuplicates As Map
	noDuplicates.Initialize
	Dataset.PrefixIndex.Initialize
	Dataset.SubstringIndex.Initialize
	Dim m As Map
	Dim li As List
	Dim Bookmark As typBookmark
	Bookmark = GetBookmark
	
	FirstRecord
	Do While Not(EOF)
		If RecNo Mod 100 = 0 Then DoEvents
		Dim item As String
		item = cIndexField.Value
		item = item.ToLowerCase
		noDuplicates.Clear
		For start = 0 To item.Length
			Dim count As Int = MIN_LIMIT
			Do While count <= MAX_LIMIT AND start + count <= item.Length
				Dim str As String
				str = item.SubString2(start, start + count)
				If noDuplicates.ContainsKey(str) = False Then 
					noDuplicates.Put(str, "")
					If start = 0 Then m = Dataset.PrefixIndex Else m = Dataset.SubstringIndex
					li = m.get(str)
					If li.IsInitialized = False Then
						li.Initialize
						m.Put(str, li)
					End If
					Dim Index(2) As Object
					Index(0) = RecordNumber
					Index(1) = cIndexField.Value
					li.Add(Index)
				End If
				count = count + 1
			Loop
		Next
		NextRecord
	Loop		
	GotoBookmark(Bookmark)
	Return True
End Sub

'Searches the Prefixes Index for the given Value. Should call BuildIndex before calling this function.
Sub SearchPrefixIndex(Value As String) As Map
	Dim li As List 
	Dim m As Map
	Dim Index(2) As Object
	m.Initialize

	If Value = "" Then
		Dim i, j As Int
		For i = 0 To Dataset.PrefixIndex.Size - 1
			li = Dataset.PrefixIndex.GetValueAt(i)
			For j = 0 To li.Size - 1
				Index = li.get(j)
				m.Put(Index(0), Index(1))
			Next
		Next
	Else
		li = Dataset.PrefixIndex.Get(Value)
		If li.IsInitialized = False Then Return Null
		For i = 0 To li.Size - 1
			Index = li.get(i)
			m.Put(Index(0), Index(1))
		Next
	End If
	Return m
End Sub

'Searches the SubStrings Index for the given Value. Should call BuildIndex before calling this function.
Sub SearchSubStringIndex(Value As String) As Map
	Dim li As List 
	li = Dataset.SubstringIndex.Get(Value)
	If li.IsInitialized = False Then Return Null
	Dim m As Map
	m.Initialize
	Dim Index(2) As Object
	For i = 0 To li.Size - 1
		Index = li.get(i)
		m.Put(Index(0), Index(1))
	Next
	Return m
End Sub

'Returns the IndexField
Sub getIndexField As ClsDBField
	Return cIndexField
End Sub

'Sets the IndexField
Sub setIndexField(Value As ClsDBField)
	If Value <> cIndexField Then
		If Value <> Null Then
			If FieldByName(Value.Name) <> Null Then
				cIndexField = Value
			Else
				Dim Ex As ExceptionEx
				
				Ex.Initialize(CodDB.SFieldNotFound.Replace("%s", Value.Name))
				Ex.Throw
			End If
		End If
	End If
End Sub

'Indicates wheter the dataset has an active index
Sub getIndexed As Boolean
	Return Dataset.PrefixIndex.Size > 0 OR Dataset.SubstringIndex.Size > 0
End Sub

'Private Sub ResetFilter
'	FirstRecord
'End Sub

'Private Sub FilterDataset
'	If bFiltered Then
'	End If
'End Sub

'Specifies the text of the current filter for a dataset
'Sub getFilter As String
'	Return strFilter
'End Sub

'Specifies the text of the current filter for a dataset
'Sub setFilter(Value As String)
'	If Value <> strFilter Then 
'		strFilter = Value
'		FilterDataset
'	End If
'End Sub

'Specifies whether or not filtering is active for a dataset.
'Sub getFiltered As Boolean
'	Return bFiltered
'End Sub

'Specifies whether or not filtering is active for a dataset.
'Sub setFiltered(Value As Boolean)
'	If Value <> bFiltered Then 
'		bFiltered = Value
'		If Value Then
'			FilterDataset
'		Else
'			ResetFilter
'		End If
'	End If
'End Sub

'Specifies whether or not filtering is case insensitive, and whether or not partial comparisons are permitted when filtering records.
'Sub getFilterOptions As Int
'	Return iFilterOptions
'End Sub

'Specifies whether or not filtering is case insensitive, and whether or not partial comparisons are permitted when filtering records.
'Sub setFilterOptions(Value As Int)
'	If Value <> iFilterOptions Then 
'		iFilterOptions = Value
'		FilterDataset
'	End If
'End Sub

'Moves the Record Pointer to RecNo AND make it the active record. Check dataset state before executing
Sub GotoRecord(NewRecNo As Long) As Boolean
	Dim result As Boolean

	CheckBrowse

	If SubExists(DBMySQLUtilsModule, OnBeforeScroll) Then CallSub2(DBMySQLUtilsModule, OnBeforeScroll, Me)

	result = False
	If NewRecNo >= 1 AND NewRecNo <= RecordCount Then
		RecordNumber = NewRecNo
		result = UpdateBuffer
	End If
	If result Then
		If SubExists(DBMySQLUtilsModule, OnAfterScroll) Then CallSub2(DBMySQLUtilsModule, OnAfterScroll, Me)
	End If
	Return  result
End Sub

'Indicates the number of field components associated with the Dataset.
Sub FieldCount As Long
	Return Dataset.FieldCount	
End Sub

'Finds a field based on its name.
Sub FieldByName(strFieldName As String) As ClsDBField
	Dim i As Long
	Dim DBField As ClsDBField
	
	If Not(Dataset.FieldsDescr.IsInitialized) OR (Dataset.FieldsDescr.Size = 0) Then
		Return Null
	Else
		For i = 0 To Dataset.FieldsDescr.Size - 1		
			DBField  = Dataset.FieldsDescr.get(i)
			If (DBField.Name.ToUpperCase = strFieldName.ToUpperCase) Then Return DBField
		Next
	End If
	Return Null
End Sub

'Finds a field based on its index.
Sub Fields(iIndex As Long) As ClsDBField
	If Not(Dataset.FieldsDescr.IsInitialized) OR (Dataset.FieldsDescr.Size = 0) OR (iIndex >= Dataset.FieldsDescr.Size) Then
		Return Null
	Else
		Return Dataset.FieldsDescr.get(iIndex)
	End If
End Sub

'Finds a parameter based on its index.
Sub Params(iParam As Long) As ClsDBParameter
	If Not(Dataset.Params.IsInitialized) OR (Dataset.Params.Size = 0) OR (iParam >= Dataset.Params.Size) Then
		Return Null
	Else
		Return Dataset.Params.get(iParam)
	End If
End Sub

'Finds a parameter based on its name.
Sub ParamByName(strParameterName As String) As ClsDBParameter
	Dim i As Long
	Dim DBParameter As ClsDBParameter
	
	If Not(Dataset.Params.IsInitialized) OR (Dataset.Params.Size = 0) Then
		Return Null
	Else
		For i = 0 To Dataset.Params.Size - 1		
			DBParameter  = Dataset.Params.get(i)
			If (DBParameter.name.ToUpperCase = strParameterName.ToUpperCase) Then Return DBParameter
		Next
	End If
	Return Null
End Sub

'Checks whether all required fields are empty or not
Sub HasEmptyRequiredField As Boolean
	Dim i As Int
	For i = 0 To FieldCount - 1
		If Fields(i).Required AND Fields(i).IsNull Then
			Return True
		End If
	Next
	Return False
End Sub

Private Sub ParseStringForParam(strScript As String, iStart As Long) As typParamParse
	Dim param As typParamParse
	Dim Delims As String = CRLF & ",;)(' "
	Dim i, iIndexDelim As Int
	
	param.Initialize
	param.IndexStart = strScript.IndexOf2(":", iStart)
	
	If param.indexstart > -1 Then	'Found some
		param.IndexEnd = -1
		For i = 0 To Delims.Length - 1
			iIndexDelim = strScript.IndexOf2(Delims.CharAt(i), param.IndexStart + 1)
			If param.IndexEnd = -1 OR (iIndexDelim >= 0 AND param.IndexEnd > iIndexDelim) Then
				param.IndexEnd = iIndexDelim
			End If
		Next
		If param.IndexEnd= -1 OR param.IndexEnd >= strScript.Length Then param.IndexEnd = strScript.Length
'		Log(param.IndexStart + 1)
'		Log(param.IndexEnd)
		param.Name = strScript.SubString2(param.IndexStart + 1, param.IndexEnd).Trim.ToLowerCase
'		Log(param.Name)
	
	End If
	Return param
End Sub

Public Sub ParseParameters
	Dim paramParse As typParamParse
	Dim paramsfound As List
	Dim strSQLScript As String
		
	paramsfound.Initialize
	Dataset.Params.Initialize
	
	'Parse SQL
	strSQLScript = SQL.ToString
	paramParse.Initialize
	paramParse = ParseStringForParam(strSQLScript, paramParse.indexstart)
	Do While paramParse.Name <> ""
'		Log(paramParse.Name)
		If ParamByName(paramParse.Name) = Null Then 
			Dim DBParameter As ClsDBParameter
			DBParameter.Initialize
			DBParameter.Name = paramParse.Name
			Dataset.Params.Add(DBParameter)
			paramsfound.Add(paramParse.Name)
		End If
		paramParse = ParseStringForParam(strSQLScript, paramParse.indexend + 1)
	Loop
	
	'Parse SQLDelete
	strSQLScript = SQLDelete.ToString
	paramParse.Initialize
	paramParse = ParseStringForParam(strSQLScript, paramParse.indexstart)
	Do While paramParse.Name <> ""
		DBParameter = ParamByName(paramParse.Name)
		If ParamByName(paramParse.Name) = Null Then 
			Dim DBParameter As ClsDBParameter
			DBParameter.Initialize
			DBParameter.Name = paramParse.Name
			Dataset.Params.Add(DBParameter)
			paramsfound.Add(paramParse.Name)
		End If
		paramParse = ParseStringForParam(strSQLScript, paramParse.indexend + 1)
	Loop

	'Parse SQLInsert
	strSQLScript = SQLInsert.ToString
	paramParse.Initialize
	paramParse = ParseStringForParam(strSQLScript, paramParse.indexstart)
	Do While paramParse.Name <> ""
		DBParameter = ParamByName(paramParse.Name)
		If ParamByName(paramParse.Name) = Null Then 
			Dim DBParameter As ClsDBParameter
			DBParameter.Initialize
			DBParameter.Name = paramParse.Name
			Dataset.Params.Add(DBParameter)
			paramsfound.Add(paramParse.Name)
		End If
		paramParse = ParseStringForParam(strSQLScript, paramParse.indexend + 1)
	Loop

	'Parse SQLLock
'	strSQLScript = SQLLock.ToString
'	paramParse.Initialize
'	paramParse = ParseStringForParam(strSQLScript, paramParse.indexstart)
'	Do While paramParse.Name <> ""
'		DBParameter = ParamByName(paramParse.Name)
'		If ParamByName(paramParse.Name) = Null Then 
'			Dim DBParameter As ClsDBParameter
'			DBParameter.Initialize
'			DBParameter.SetName(paramParse.Name)
'			Dataset.Params.Add(DBParameter)
'			paramsfound.Add(paramParse.Name)
'		End If
'		paramParse = ParseStringForParam(strSQLScript, paramParse.indexend + 1)
'	Loop

	'Parse SQLRefresh
	strSQLScript = SQLRefresh.ToString
	paramParse.Initialize
	paramParse = ParseStringForParam(strSQLScript, paramParse.indexstart)
	Do While paramParse.Name <> ""
		DBParameter = ParamByName(paramParse.Name)
		If ParamByName(paramParse.Name) = Null Then 
			Dim DBParameter As ClsDBParameter
			DBParameter.Initialize
			DBParameter.Name = paramParse.Name
			Dataset.Params.Add(DBParameter)
			paramsfound.Add(paramParse.Name)
		End If
		paramParse = ParseStringForParam(strSQLScript, paramParse.indexend + 1)
	Loop

	'Parse SQLUpdate
	strSQLScript = SQLUpdate.ToString
	paramParse.Initialize
	paramParse = ParseStringForParam(strSQLScript, paramParse.indexstart)
	Do While paramParse.Name <> ""
		DBParameter = ParamByName(paramParse.Name)
		If ParamByName(paramParse.Name) = Null Then 
			Dim DBParameter As ClsDBParameter
			DBParameter.Initialize
			DBParameter.Name = paramParse.Name
			Dataset.Params.Add(DBParameter)
			paramsfound.Add(paramParse.Name)
		End If
		paramParse = ParseStringForParam(strSQLScript, paramParse.indexend + 1)
	Loop

	For i = 0 To Dataset.Params.Size - 1
		DBParameter = Dataset.Params.get(i)
		If paramsfound.IndexOf(DBParameter.Name) = -1 Then Dataset.Params.RemoveAt(i)
	Next
End Sub

'Return the latest error number
Public Sub ErrorNumber As Long
	Return Dataset.ErrorNumber
End Sub

'Return the latest error description
Public Sub ErrorDescr As Long
	Return Dataset.ErrorDescr
End Sub

Private Sub getGUID As Object
    Dim r As Reflector
    r.Target = r.RunStaticMethod("java.util.UUID", "randomUUID", Null, Null)
    Return r.RunMethod("toString")
End Sub

'Return the Dataset State
Public Sub State As Int
	Return intState
End Sub

'Check if the dataset is active. Otherwise throw an exception
Private Sub CheckActive
	Dim Ex As ExceptionEx
	
	If Not(Dataset.IsInitialized) OR Not(Dataset.Rows.IsInitialized) OR (State = CodDB.dsInactive)  Then
		Ex.Initialize(CodDB.SDataSetClosed)
		Ex.Throw
	End If
End Sub

'Check if the dataset is active and in browse mode. Otherwise throw an exception
Private Sub CheckBrowse
	Dim Ex As ExceptionEx
	
	CheckActive	
	
	If State <> CodDB.dsBrowse  Then
		Ex.Initialize(CodDB.SDataSetNotBrowse)
		Ex.Throw
	End If	
End Sub

'Check if the dataset is in insert or edit mode. Otherwise throw an exception
Private Sub CheckInsertOtEdit
	Dim Ex As ExceptionEx
	
	If Not(Dataset.IsInitialized) OR Not(Dataset.Rows.IsInitialized) OR (State = CodDB.dsInactive)  Then
		Ex.Initialize(CodDB.SDataSetClosed)
		Ex.Throw
	End If
	
	If State <> CodDB.dsInsert AND State <> CodDB.dsEdit Then
		Ex.Initialize(CodDB.SNotEditing)
		Ex.Throw
	End If	
End Sub

'Subscribe View to receive Dataset's events
Sub SubscribeModule(Module As Object)
	Dim DBAwareAction As typDBAwareAction 
	
	DBAwareAction.Initialize
	DBAwareAction.Module = Module
	DBAwareEvents.Add(DBAwareAction)
	If SubExists(DBAwareAction.Module, "DataChange") Then CallSub(DBAwareAction.Module, "DataChange")
End Sub

Private Sub CallDataChange
	Dim i As Int
	Dim DBAwareAction As typDBAwareAction 
	
	For i = 0 To DBAwareEvents.Size - 1
		DBAwareAction = DBAwareEvents.get(i)
		If SubExists(DBAwareAction.Module, "DataChange") Then CallSub(DBAwareAction.Module, "DataChange")
	Next
End Sub

'Returns the MySQL Connection
Sub getMySQLConnection As ClsDBMySQLConnection
	Return DBMySQLConnection
End Sub