﻿Type=Class
Version=2.71
@EndOfDesignText@
'ClsDBMySQLconnection v1.4
'Basic4Android v2.70 Class
'Developed by QUALISYS SOFTWARE

'Class module
Sub Class_Globals
	Type typeScript(TunnelVersion, ServerVersion, Script, ErrorNumber, ErrorDescr, RowsAffected, LastInsert_ID As String, Params As List)
	Type typParamParse(Name As String, IndexStart, IndexEnd As Long)
			
	Private DBMySQLConnection As ClsDBMySQLConnection
	Private DBMySQLUtilsModule As Object
	Public  SQL 			As ClsDBSQLScript
'	Private NullValue       As String : NullValue = Chr(0)
	Private Dataset 		As typeScript
	
	'Tag
	Public Tag As Object
	
	'JSONDecoding Events
	Public OnErrorDecoding As String
	
	'Execute Events
	Public OnBeforeExecute As String
	Public OnAfterExecute As String
	Public OnErrorExecute As String	
End Sub

'Initializes ClsDBMySQLDataset.
'MySQLConnection = MySQLConnection AS typMySQLConnection
'Module          = Me
Public Sub Initialize(MySQLConnection As ClsDBMySQLConnection, Module As Object)
	DBMySQLConnection = MySQLConnection
	DBMySQLUtilsModule = Module
	Dataset.Initialize
	Dataset.Params.Initialize
	
	SQL.Initialize(Me)
End Sub

'Change the activity that holds the events to be called
'Module			= Me
Public Sub ChangeEventsToActivity(Module As Object)
	DBMySQLUtilsModule = Module
End Sub

Private Sub ParseSQL(strIntSQL As String) As String
	Dim sParam As String
	Dim paramParse As typParamParse	
	Dim DBParameter As ClsDBParameter
	Dim mResult, mParams, mParam As Map
	
	mResult.Initialize
	mParams.Initialize

	paramParse.Initialize
	paramParse = ParseStringForParam(strIntSQL, paramParse.indexstart)
	Do While paramParse.Name <> ""
		mParam.Initialize
		'Parse Parameters
		DBParameter = ParamByName(paramParse.Name)
		If DBParameter <> Null Then
			If DBParameter.Value = Null Then
				sParam = "NULL"
			Else			
				Select DBParameter.ParamType
					Case CodDB.ftVARCHAR, CodDB.ftCHAR, CodDB.ftUNKNWOWN
						sParam = DBParameter.StringValueAsBase64
						mParam.Put("addsinglequotes", "true")
						mParam.Put("encoding", "base64")
					Case CodDB.ftSMALLINT, CodDB.ftTINYINT, CodDB.ftINT, CodDB.ftFLOAT, CodDB.ftDOUBLE, CodDB.ftBIT, CodDB.ftBIGINT, CodDB.ftMEDIUMINT, CodDB.ftYEAR  
						sParam = DBParameter.Value
					Case CodDB.ftTIMESTAMP, CodDB.ftDATE, CodDB.ftTIME, CodDB.ftDATETIME
						Dim dt As Long = DBParameter.AsDateTime
						Dim day As Int  = DateTime.GetDayOfMonth(dt)
						Dim month As Int = DateTime.GetMonth(dt)
						Dim year As Int  = DateTime.GetYear(dt)
						Dim hour As Int  = DateTime.GetHour(dt)
						Dim minute As Int = DateTime.GetMinute(dt)
						Dim second As Int = DateTime.GetSecond(dt)
						sParam = "STR_TO_DATE('" & year & "-" & month & "-" & day & " " & hour & ":" & minute & ":" & second & "', '%Y-%m-%d %H:%i:%s')"
					Case CodDB.ftBLOB, CodDB.ftLONGBLOB, CodDB.ftMEDIUMBLOB, CodDB.ftTINYBLOB
						sParam = DBParameter.StringValueAsBase64
						mParam.Put("addsinglequotes", "true")
						mParam.Put("encoding", "base64")
					Case CodDB.ftBOOLEAN
						sParam = DBParameter.Value
					Case CodDB.ftENUM, CodDB.ftSET, CodDB.ftGEOMETRY
						sParam = "'" & DBParameter.Value & "'"
					Case Else
						sParam = DBParameter.StringValueAsBase64
						mParam.Put("addsinglequotes", "true")
						mParam.Put("encoding", "base64")
				End Select
			End If
			
			'strIntSQL = strIntSQL.SubString2(0, paramParse.indexstart) & sParam & strIntSQL.SubString2(paramParse.IndexEnd, strIntSQL.Length)
			mParam.Put("value", sParam)
			mParams.Put(DBParameter.Name, mParam)
		End If
		
		paramParse = ParseStringForParam(strIntSQL, paramParse.IndexEnd)
	Loop
	
	mResult.Put("SQL", strIntSQL)
	mResult.Put("params", mParams)
	Dim JSONGenerator As JSONGenerator
	
	JSONGenerator.Initialize(mResult)
		
	Return JSONGenerator.ToString
End Sub


'Execute The SQL Query. Return True on success, False otherwise. You might want to check the dataset's state before executing.
Public Sub Execute As Boolean
	Dim sSQLParsed As String
	Dim Ex As ExceptionEx
	
	If SQL.ToString.Trim = ""  Then
		Ex.Initialize(CodDB.SDataSetNoSQLScript)
		Ex.Throw
	End If	
		
	If SubExists(DBMySQLUtilsModule, OnBeforeExecute) Then CallSub2(DBMySQLUtilsModule, OnBeforeExecute, Me)

	'Parse Parameters to Values
	sSQLParsed = ParseSQL(SQL.ToString)
	
	DBMySQLConnection.ExecuteScript(sSQLParsed, "JobScriptExecute_Done", "JobScriptExecute_Failure", Me)
	Return True
End Sub

Private Sub JobScriptExecute_Done(Result As String, cDBMySQLConnection As ClsDBMySQLConnection)
	Dim bDecoded As Boolean = JSONDecodeHeaders(Result)
	If Not(bDecoded) Then			
		If SubExists(DBMySQLUtilsModule, OnErrorDecoding) Then 
			CallSub3(DBMySQLUtilsModule, OnErrorDecoding, Result, Me)
		Else
			Dim Ex As ExceptionEx
			
			Ex.Initialize(CodDB.SDecodeError)
			Ex.Throw			
		End If
	Else If	Dataset.ErrorNumber <> 0 Then
		If SubExists(DBMySQLUtilsModule, OnErrorExecute) Then 
			CallSub3(DBMySQLUtilsModule, OnErrorExecute, Dataset.ErrorDescr, Me)
		Else
			Dim Ex As ExceptionEx
			
			Ex.Initialize(CodDB.SExecuteError)
			Ex.Throw			
		End If
	Else
		If SubExists(DBMySQLUtilsModule, OnAfterExecute) Then 
			CallSub2(DBMySQLUtilsModule, OnAfterExecute, Me)
		End If
	End If	
End Sub

Private Sub JobScriptExecute_Failure(ErrorMessage As String, cDBMySQLConnection As ClsDBMySQLConnection)
    Log("HTTP Request Error: " & ErrorMessage)
	If SubExists(DBMySQLUtilsModule, OnErrorExecute) Then CallSub3(DBMySQLUtilsModule, OnErrorExecute, ErrorMessage, Me)
End Sub

Private Sub JSONDecodeHeaders(strResponse As String) As Boolean
	Dim jsonResponse As JSONParser
	Dim mapResult As Map
	
	jsonResponse.Initialize(strResponse)
	mapResult = jsonResponse.NextObject
	
	Dataset.TunnelVersion 	= mapResult.Get("tunnelversion")
	Dataset.ServerVersion 	= mapResult.Get("serverversion")
	Dataset.ErrorNumber 	= mapResult.Get("errornumber")
	Dataset.ErrorDescr 		= mapResult.Get("errordescr")
	Dataset.RowsAffected	= mapResult.Get("affectedrows")
	Dataset.LastInsert_ID	= mapResult.Get("lastinsert_id")
	Return True
End Sub

'Finds a parameter based on its index.
Sub Params(iParam As Long) As ClsDBParameter
	If Not(Dataset.Params.IsInitialized) OR (Dataset.Params.Size = 0) OR (iParam >= Dataset.Params.Size) Then
		Return Null
	Else
		Return Dataset.Params.Get(iParam)
	End If
End Sub

'Finds a parameter based on its name.
Sub ParamByName(strParameterName As String) As ClsDBParameter
	Dim i As Long
	Dim DBParameter As ClsDBParameter
	
	If Not(Dataset.Params.IsInitialized) OR (Dataset.Params.Size = 0) Then
		Return Null
	Else
		For i = 0 To Dataset.Params.Size - 1		
			DBParameter  = Dataset.Params.Get(i)
			If (DBParameter.Name.ToUpperCase = strParameterName.ToUpperCase) Then Return DBParameter
		Next
	End If
	Return Null
End Sub

Private Sub ParseStringForParam(strScript As String, iStart As Long) As typParamParse
	Dim param As typParamParse
	Dim Delims As String = CRLF & ",;)(' "
	Dim i, iIndexDelim As Int
	
	param.Initialize
	param.IndexStart = strScript.IndexOf2(":", iStart)
	
	If param.indexstart > -1 Then	'Found some
		param.IndexEnd = -1
		For i = 0 To Delims.Length - 1
			iIndexDelim = strScript.IndexOf2(Delims.CharAt(i), param.IndexStart + 1)
			If (iIndexDelim >= 0) AND (param.IndexEnd = -1 OR param.IndexEnd > iIndexDelim) Then
				param.IndexEnd = iIndexDelim
			End If
		Next
		If param.IndexEnd= -1 OR param.IndexEnd >= strScript.Length Then param.IndexEnd = strScript.Length
'		Log(param.IndexStart + 1)
'		Log(param.IndexEnd)
		param.Name = strScript.SubString2(param.IndexStart + 1, param.IndexEnd).Trim.ToLowerCase
'		Log(param.Name)
	
	End If
	Return param
End Sub

Public Sub ParseParameters
	Dim paramParse As typParamParse
	Dim paramsfound As List
	Dim strSQLScript As String
		
	paramsfound.Initialize
	Dataset.Params.Initialize
	
	'Parse SQL
	strSQLScript = SQL.ToString
	paramParse.Initialize
	paramParse = ParseStringForParam(strSQLScript, paramParse.indexstart)
	Do While paramParse.Name <> ""
		
		If ParamByName(paramParse.Name) = Null Then 
			Dim DBParameter As ClsDBParameter
			DBParameter.Initialize
			DBParameter.Name = paramParse.Name
			Dataset.Params.Add(DBParameter)
			paramsfound.Add(paramParse.Name)
		End If
		paramParse = ParseStringForParam(strSQLScript, paramParse.indexend + 1)
	Loop
	
	For i = 0 To Dataset.Params.Size - 1
		DBParameter = Dataset.Params.Get(i)
		If paramsfound.IndexOf(DBParameter.Name) = -1 Then Dataset.Params.RemoveAt(i)
	Next
End Sub

'Return the latest error number
Public Sub ErrorNumber As Long
	Return Dataset.ErrorNumber
End Sub

'Return the latest error description
Public Sub ErrorDescr As Long
	Return Dataset.ErrorDescr
End Sub

Private Sub getGUID As Object
    Dim r As Reflector
    r.Target = r.RunStaticMethod("java.util.UUID", "randomUUID", Null, Null)
    Return r.RunMethod("toString")
End Sub